require_relative './reviewer'
module StudioGame
  class Movie
    include Reviewer
    attr_reader :title
    attr_reader :rank
    attr_reader :movie_type
    def initialize(title, rank=0, movie_type=:two_d)
      @title = title.capitalize
      @rank = Integer(rank)
      @movie_type = if movie_type.nil?
        :two_d
      else
        movie_type
      end
    end
    def self.from_csv(line)
      name, rank, movie_type = line.split(",")
      Movie.new(name, rank, movie_type)
    end
    def t_up
      @rank += 1
    end
    def t_down
      @rank -= 1
    end
    def hit?
      @rank > 10
    end
    def play
      "Playing movie #{@title}, that is having rank : #{@rank}"
    end
    def to_csv
      "#{title},#{rank}"
    end
    def to_s
      "Movie #{@title}, that is having rank : #{@rank}, movie_type: #{movie_type}"
    end
    def <=>(other_movie)
      other_movie.rank <=> rank
    end
  end
  $PROGRAM_NAME
  $0
  if $0 == __FILE__
    m1 = Movie.new("race", 10, nil)
    m1.play
    puts m1
  end
end