require_relative "./movie"
require_relative './movie_validator'
module StudioGame
  class Playlist
    attr_reader :title, :movies

    def initialize(title)
      @title = title
      @movies = [] 
    end

    def load_from_file(file_name)
      File.open(file_name) do |file|
        file.each_line do |line|
          add_movie Movie.from_csv(line)
        end
      end   
    end

    def add_movie(movie)
      if MovieValidator.valid_movie_object?(movie)
        @movies.push(movie)
      else
        false
      end
    end

    def include?(movie)
      @movies.include? movie
    end

    def save
      File.open("./../files/playlist_movies.csv", "w") do |file|
        movies.each do |movie|
          file.write movie.to_csv
          file.write "\n"
        end
      end
    end

    def print_stats
      puts "print_stats"
      @movies.sort.each do |movie|
        puts movie.to_s
      end
    end

    def play(view_count)
      puts "-------- Playing Playlist \"#{@title}\"--------"
      1.upto(Integer(view_count)) do |count|
        puts "\nViewing Playlist #{@title} #{count} time"
        @movies.each do |movie|
          movie.review
        end
      end
    end
  end
end

    pl1 = StudioGame::Playlist.new("Raghvendra")
    pl1.load_from_file(File.expand_path("./../../files/movies.csv",__FILE__))
    puts "Please give the number of view_count..!"
    view_count = gets.chomp
    puts "view_count : #{view_count} ......TODO Use this with play!"
    pl1.play(view_count)
    puts "---------------"
    pl1.print_stats